<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>Index</title>
    <style>
      .country-customer {
        display: block;
        margin: 0 auto;
        width: 100%;
      }
    </style>
</head>
<body>
    <div class="container">
        <div class="text-center">
          <h2>Courses List</h2>
        </div>
        <div class="form-group">
          <button class="btn btn-success" id="btn-add-course"><i class="fa fa-plus"></i>&nbsp; New Course</button>
        </div>
      </div>
      <!-- Vouche Data Table -->
      <div class="container">
        <table class="table table-bordered table-striped table-hover" id="course-table">
          <thead>
            <tr>
              <th>ID</th>
              <th>Course Code</th>
              <th>Course Name</th>
              <th>Cover Image</th>
              <th>Discount Price</th>
              <th>Price</th>
              <th>Duration</th>
              <th>Level</th>
              <th>Teacher</th>
              <th>Teacher Photo</th>
              <th>Popular</th>
              <th>Trending</th>
              <th>Action</th>
            </tr>
          </thead>
        </table>
      </div>

      <!--Modal Create-->

      <div class="modal" tabindex="-1" role="dialog" id="modal-add-course">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Create Course</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <div class="container">
                <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Course Code</label>
                    <input class="form-control" type="text" id="inp-course-code" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="html">Course Name</label>
                  <input class="form-control" type="text" id="inp-course-name" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="html">Price</label>
                  <input class="form-control" type="text" id="inp-price" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="html">Discount Price</label>
                  <input class="form-control" type="text" id="inp-discount-price" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="html">Duration</label>
                  <input class="form-control" type="text" id="inp-duration" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="html">Cover Image</label>
                  <input class="form-control" type="text" id="inp-cover-img" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="html">Teacher Name</label>
                  <input class="form-control" type="text" id="inp-teacher-name" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="html">Teacher Photo</label>
                  <input class="form-control" type="text" id="inp-teacher-photo" placeholder="...">
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="popular-checkbox">Popular</label>
                  <div class="form-check">
                    <input class="form-check-input" type="checkbox" id="popular-checkbox">
                  </div>
                </div>
                <div class="form-group text-center" style="margin-top: 20px;">
                  <label for="trending-checkbox">Trending</label>
                  <div class="form-check">
                    <input class="form-check-input" type="checkbox" id="trending-checkbox">
                  </div>
                </div>
                <div class="form-group text-center">
                  <label for="html">Level</label>
                  <select class="form-control country-customer text-center" name="level" id="level-select" style="width: 200px;">
                      <option value="Beginner">Beginner</option>
                      <option value="Intermediate">Intermediate</option>
                      <option value="Advanced">Advanced</option>
                  </select>
                </div>
              </div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-primary" id="btn-create-course">Create Course</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
            </div>
          </div>
        </div>
      </div>

      <!--Modal Update-->
      <div class="modal fade" id="modal-update" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title"></h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <div class="modal-body">
                <div class="container">
                  <div class="form-group text-center" style="margin-top: 20px;">
                      <label for="html">Course Code</label>
                      <input class="form-control" type="text" id="inp-course-code-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Course Name</label>
                    <input class="form-control" type="text" id="inp-course-name-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Price</label>
                    <input class="form-control" type="text" id="inp-price-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Discount Price</label>
                    <input class="form-control" type="text" id="inp-discount-price-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Duration</label>
                    <input class="form-control" type="text" id="inp-duration-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Cover Image</label>
                    <input class="form-control" type="text" id="inp-cover-img-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Teacher Name</label>
                    <input class="form-control" type="text" id="inp-teacher-name-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="html">Teacher Photo</label>
                    <input class="form-control" type="text" id="inp-teacher-photo-update" placeholder="...">
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="popular-checkbox">Popular</label>
                    <div class="form-check">
                      <input class="form-check-input" type="checkbox" id="popular-checkbox-update">
                    </div>
                  </div>
                  <div class="form-group text-center" style="margin-top: 20px;">
                    <label for="trending-checkbox">Trending</label>
                    <div class="form-check">
                      <input class="form-check-input" type="checkbox" id="trending-checkbox-update">
                    </div>
                  </div>
                  <div class="form-group text-center">
                    <label for="html">Level</label>
                    <select class="form-control country-customer text-center" name="level" id="level-select-update" style="width: 200px;">
                        <option value="Beginner">Beginner</option>
                        <option value="Intermediate">Intermediate</option>
                        <option value="Advanced">Advanced</option>
                    </select>
                  </div>
                </div>
              </div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              <button type="button" class="btn btn-primary" id="btn-update-course">Update</button>
            </div>
          </div>
        </div>
      </div>

      <!--Modal Delete-->
      <div>
        <div class="modal fade" tabindex="-1" id="modal-delete">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Course Delete Confirmation</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <label>Do you want to delete this course ?</label>
              </div>
              <div class="modal-footer">
                <button class="btn btn-danger" id="btn-delete">Confirm</button>
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
</body>
<script>

  var gBASE_URL = "https://630890e4722029d9ddd245bc.mockapi.io/api/v1/courses";
  var gCoursesList = {};
  var gCourseID = 0;

  $(document).ready(function() {
    onPageLoading();
    addEventsToBtn();
  })
  function onPageLoading() {
    $.ajax({
      url: gBASE_URL,
      type: "GET",
      dataType: "json",
      success: function(req) {
        gCoursesList = req;
        console.log(gCoursesList);
        $("#course-table").DataTable({
            data : gCoursesList,
            columns: [
              {data: 'id'},
              {data: 'courseCode'},
              {data: 'courseName'},
              {data: 'coverImage',
              render: function (data, type, row) {
                return '<img src="' + data + '" class="img-thumbnail" width="100"/>';
              }},
              {data: 'discountPrice'},
              {data: 'price'},
              {data: 'duration'},
              {data: 'level'},
              {data: 'teacherName'},
              {data: 'teacherPhoto',
              render: function (data, type, row) {
                return '<img src="' + data + '" class="img-thumbnail" width="100"/>';
              }},
              {data: 'isPopular'},
              {data: 'isTrending'},
              {title: 'Action'},
            ],
            columnDefs: [
                { 
                  targets: -1,
                  defaultContent: `
                  <img class="edit-course" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                  <img class="delete-course" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
                }
            ]
        });
      },
      error: function(paramError) {
        console.log(paramError.responseText);
      }
    })
  }
  
  
  function addEventsToBtn() {
    //Create Course
    $("#btn-add-course").on("click",function() {
      $("#modal-add-course").modal("show");
      createCourseBtn();
    })
    //Update Course
    $("#course-table").on("click",".edit-course",function() {
      loadDataCourseToModalUpdate(this);
    })
    $("#btn-update-course").on("click",function() {
      updateCourse();
    })

    //Delete Course
    $("#course-table").on("click",".delete-course",function() {
      deleteCourseModal(this);
    })
    $("#btn-delete").on("click",function() {
      deleteCourse();
    })
  }
  function deleteCourseModal(paramDeleteBtn) {

    var row = $(paramDeleteBtn).closest("tr");
    var rowData = $("#course-table").DataTable().row(row).data();
    gCourseID = rowData.id;

    $("#modal-delete").modal("show");
  }
  function deleteCourse() {

      $.ajax({
        url: gBASE_URL +"/"+ gCourseID,
        type: "DELETE",
        success: function() {
          handleDeleteCourseSuccess();
        },
        error: function(paramError) {
          alert(paramError.responseText);
          $("#modal-delete").modal("hide");
      }
    });
  }
  function handleDeleteCourseSuccess() {
    $("#course-table").DataTable().destroy();
    onPageLoading();
    $("#modal-delete").modal("hide");
  }

  function loadDataCourseToModalUpdate(paramBtnEdit) {

    var row = $(paramBtnEdit).closest("tr");
    var rowData = $("#course-table").DataTable().row(row).data();

    $("#inp-course-code-update").val(rowData.courseCode)
    $("#inp-course-name-update").val(rowData.courseName)
    $("#inp-price-update").val(rowData.price)
    $("#inp-discount-price-update").val(rowData.discountPrice)
    $("#inp-duration-update").val(rowData.duration)
    $("#inp-cover-img-update").val(rowData.coverImage)
    $("#inp-teacher-name-update").val(rowData.teacherName)
    $("#inp-teacher-photo-update").val(rowData.teacherPhoto)
    $("#popular-checkbox-update").prop("checked",rowData.isPopular),
    $("#popular-checkbox-update").prop("checked",rowData.isTrending),
    $("#level-select-update").val(rowData.level)

    gCourseID = rowData.id;
    console.log(gCourseID);

    $("#modal-update").modal("show");

  }
  function updateCourse() {

    var course = {
            courseCode: $("#inp-course-code-update").val().trim(),
            courseName: $("#inp-course-name-update").val().trim(),
            price: $("#inp-price-update").val().trim(),
            discountPrice: $("#inp-discount-price-update").val().trim(),
            duration: $("#inp-duration-update").val().trim(),
            coverImage: $("#inp-cover-img-update").val().trim(),
            teacherName: $("#inp-teacher-name-update").val().trim(),
            teacherPhoto: $("#inp-teacher-photo-update").val().trim(),
            isPopular: $("#popular-checkbox-update").prop("checked"),
            isTrending: $("#popular-checkbox-update").prop("checked"),
            level: $("#level-select-update").val(),
        };

    $.ajax({
        url: gBASE_URL +"/"+ gCourseID,
        type: "PUT",
        dataType: "json",
        contentType: "application/json",
        data: JSON.stringify(course),
        success: function(response) {
            console.log(response);
            handleUpdateCourseSuccess();
        },
        error: function(paramError) {
            alert(paramError.responseText);
            $("#modal-update").modal("hide");
        }
    });
  }
  function handleUpdateCourseSuccess() {
    $("#course-table").DataTable().destroy();
    onPageLoading();
    $("#modal-update").modal("hide");
  }

  function createCourseBtn() {
    $("#btn-create-course").on("click",function() {
      var course = {
            courseCode: $("#inp-course-code").val().trim(),
            courseName: $("#inp-course-name").val().trim(),
            price: $("#inp-price").val().trim(),
            discountPrice: $("#inp-discount-price").val().trim(),
            duration: $("#inp-duration").val().trim(),
            coverImage: $("#inp-cover-img").val().trim(),
            teacherName: $("#inp-teacher-name").val().trim(),
            teacherPhoto: $("#inp-teacher-photo").val().trim(),
            isPopular: $("#popular-checkbox").prop("checked"),
            isTrending: $("#popular-checkbox").prop("checked"),
            level: $("#level-select").val(),
        };
        var vValid = validateCourse(course);

        if (vValid) {
            $.ajax({
            url: gBASE_URL,
            type: "POST",
            dataType: "json",
            contentType: "application/json",
            data: JSON.stringify(course),
            success: function(req) {
              handleCreateCourseSuccess();
            },
            error: function(paramError) {
              console.log(paramError.responseText);
            }
          })
        }      
    })
  }
  function handleCreateCourseSuccess() {
    $("#course-table").DataTable().destroy();
    onPageLoading();
    $("#inp-course-code, #inp-course-name, #inp-price,#inp-discount-price,#inp-duration,#inp-cover-img,#inp-teacher-name,#inp-teacher-photo").val("");
    $("#modal-add-course").modal("hide");
  }
  function validateCourse(paracourse) {

    if (paracourse.courseCode == "") {
      alert("Invalid!");
      $('#inp-course-code').focus();
      return false
    }
    if (paracourse.courseName == "") {
      alert("Invalid!");
      $('#inp-course-name').focus();
      return false
    }
    if (paracourse.price == "") {
      alert("Invalid!");
      $('#inp-price').focus();
      return false
    }
    if (paracourse.discountPrice == "") {
      alert("Invalid!");
      $('#inp-discount-price').focus();
      return false
    }
    if (paracourse.duration == "") {
      alert("Invalid!");
      $('#inp-duration').focus();
      return false
    }
    if (paracourse.coverImage == "") {
      alert("Invalid!");
      $('#inp-cover-img').focus();
      return false
    }
    if (paracourse.teacherName == "") {
      alert("Invalid!");
      $('#inp-course-code').focus();
      return false
    }
    if (paracourse.teacherPhoto == "") {
      alert("Invalid!");
      $('#inp-course-code').focus();
      return false
    }
    return true;
  }
</script>
</html>